# PF - Release notes

## Releases

Pure komt elk kwartaal met een nieuwe minor version.
Sinds eind september 2019 is dat 5.15.
De volledige versie werd toen 5.15.2-3.
Iedere nieuwe minor release brengt een nieuwe API.
Bij minor versie 5.15 is dat '515'.
Zo'n API-versie (hoe stel je queries op en hoe zien de responses van de webservices eruit) blijft een tijdlang supported.
Pure ondersteunt dus meerdere API-versies tegelijk.
Volgen van de nieuwste API maakt dat de veranderingen steeds overzichtelijk blijven en dat de laatste versie van PF altijd nog tijd mee gaat.

PF komt ieder kwartaal uit met een nieuwe versie.
Dat is nadat de nieuwe API is verwerkt in de code.
PF volgt daarmee de releases van Pure.
Eventuele bugfixes en verbeteringen in PF van de maanden ervoor, worden dan ook doorgevoerd.
Als een aanpassing niet kan wachten, komt er een tussentijdse versie uit.

De versienummering X.Y.Z (major.minor.incremental/build) volgt vanaf oktober 2019 de API-nummering van Pure v.w.b. X.Y.
Het laatste ('Z') is het build nummer.

## Versie 5.16 (2019-12)

- Indien in Pure een employeeEndDate staat voor persoon,
  en deze employeeEndDate ligt in het verleden,
  dan Pure-data niet opnemen in profieldata t.b.v. XML; dit voorkomt URLs naar Pure die niet meer werken

## Versie 5.15.6 (2019-10-01)

- PF is af
- Verbeterd Manifest in /status; het toont weer alle relevante gegevens, waaronder versie
- Unescaped \&amp;amp; in APA in de RSS
- Code en data voor test-accounts met fake data verwijderd
- Naar API versie 5.15 van Pure Webservices

## Versie 0.9 (2019-08-12)

- Titel-veld in publicatielijsten profieldata voortaan ontdaan van HTML tags, o.a. \&amp;
- UUID van wetenschapper in Pure ook op te zoeken met ANR
- Drupal-id opvragen op basis van ANR mogelijk

## Versie 0.8 (2019-06-04)

- Gebaseerd op versie 0.6.7
- Gevaarlijke en ongewenste calls verwijderd, zoals upload van XML en forceren van genereren XML; waren nuttig tijdens testfase
- In documentatie uitleg in de vorm van UML sequence diagrammen (gebruikt PlantUML)
- Naar API versie 5.14 van Pure Webservices (grote veranderingen)
- Highlighted publicaties via nieuwe API call die van onderzoeker een andere selectie vereist; oude CV-methode werkt ook nog

## Versie 0.7 (niet uitgebracht)

- Vastgelopen bij te grote veranderingen; daarom niet verder mee gegaan en geen release van gehad

## Versie 0.6.7 (2019-04-11)

- Als in XML met profieldata verplichte voornaam ontbreekt, wordt deze gevuld met initialen of met 'NN' als ook initialen ontbreken
- Titels van publicaties kunnen uit Pure komen met encoding te veel; daarom titel standaard extra XML decode doen voor XML met profieldata

## Versie 0.6.6 (2019-03-19)

- Manifest-velden in de status-pagina, zodat bouwer, bouwdatum, versie en bouwtool-versies te zien zijn
- Request parameter publication-year bij series wordt bij -10 t/m +10 beschouwd als relatief ten opzichte van het huidige jaar
- Request parameter publication-year bij series heeft default waarde 0, dus het huidige jaar
- Request parameter document-type bij series heeft default waarde 'thesisdoc'
- Verzoeken aan Pure Webservices worden deels gevalideerd

## Versie 0.5 (2019-01-24)

- Naar API versie 5.13 van Pure Webservices
- RSS van publicaties van organisatie
  en alle suborganisaties (o.b.v. id of UUID van organisatie),
  gesorteerd op afnemende publicatiedatum
- Modus genereren EE-data in configuratie te regelen, een van deze opties:
  - 10% van personeel als Test, met email-adres @example.com
  - 10% van personeel als Productie, met email-adres @uvt.nl
  - 100% van personeel als Productie, met email-adres @uvt.nl

## Versie 0.4 (2018-12-11)

- Paar niet gebruikte opties weer verwijderd
- Aanmaken en cachen van de persoonsdata voor Webwijs toegevoegd,
  met cron-triggering en ad-hoc-triggering
  inclusief het kunnen ophalen en zelfs vervangen van gecachete bestand
- Status-pagina toont situatie rond Webwijs-XML en job voor aanmaken data
- Bouw Debian-package grotendeels via Maven assembly spaart veel shell-script-code

## Versie 0.2 (2018-08-16)

- Gebruik matrix-parameters in URLs om personen aan te duiden,
  bijvoorbeeld '/persons/person;mailname=j.j.sijtsema/...'
- Meest recente publicaties wetenschappers, evt. geencodeerd, als XML en HTML verwijderd;
  deze optie zat er in om uitvallen oude Pure webservices op te kunnen vangen voordat GX zou zijn uitgefaseerd
- Experts & Expertise-data (Webwijs) uit Pure beschikbaar per persoon,
  precies zoals deze in de XML moet komen,
  met o.a. voorkeurs- of recente publicaties
- Uitgebreide tests op juiste gebruik URLs
- HTTP status codes 400 (BAD REQUEST) en 404 (NOT FOUND) bij foute aanroep respectievelijk niet gevonden persoon

## Versie 0.1 (2018-05-31)

- UUID van wetenschapper op basis van mailnaam
- Meest recente publicaties wetenschappers, evt. geencodeerd, als XML en HTML
- Series, zoals CentER Discussion Paper-series, voor een jaar, gesorteerd op afnemend volume als RSS

